/******************************************************************
Programmation de la PMI - BTS 2000

Programme devinant la direction a prendre a partir
du point actuel, en fonction du point precedent
et du point a rejoindre.

Version fonctionnelle - revision du 06-05-2000


Programme par OLLIVIER Vincent.
********************************************************************/

#include "c:\temp\yxia\general.h"


/********************************************************************
represente tous les cas possible de positionnement du robot
pour tout les points de la table QUAND LE ROBOT EST EN MARCHE AVANT!
Si le robot est en marche arriere il faut simplement inverser
le virage et le parcours reste le meme.

ATTENTION : Ne pas modifier par logiciel cette structure.

Faire executer ce code pendant l' init de la PMI !
Cette structure est impressionnante mais n'occupe que 360 octets.
********************************************************************/
void represTable (vertex v[])
{
/************ V0 ************/
v[0].pos[0].pointPrecdt = 9;
v[0].pos[0].pointPosble = 1;
v[0].pos[0].virage = GAUCHE;
v[0].pos[0].parcours = 3;

v[0].pos[1].pointPrecdt = 1;
v[0].pos[1].pointPosble = 9;
v[0].pos[1].virage = DROITE;
v[0].pos[1].parcours = 1;

v[0].pos[2].pointPrecdt = 9;
v[0].pos[2].pointPosble = 9;
v[0].pos[2].virage = DEMIT;
v[0].pos[2].parcours = 1;

v[0].pos[3].pointPrecdt = 1;
v[0].pos[3].pointPosble = 1;
v[0].pos[3].virage = DEMIT;
v[0].pos[3].parcours = 3;

/************ V1 ************/
v[1].pos[0].pointPrecdt = 0;
v[1].pos[0].pointPosble = 2;
v[1].pos[0].virage = DEVANT;
v[1].pos[0].parcours = 2;

v[1].pos[1].pointPrecdt = 0;
v[1].pos[1].pointPosble = 7;
v[1].pos[1].virage = GAUCHE;
v[1].pos[1].parcours = 4;

v[1].pos[2].pointPrecdt = 2;
v[1].pos[2].pointPosble = 7;
v[1].pos[2].virage = DROITE;
v[1].pos[2].parcours = 4;

v[1].pos[3].pointPrecdt = 2;
v[1].pos[3].pointPosble = 0;
v[1].pos[3].virage = DEVANT;
v[1].pos[3].parcours = 3;

v[1].pos[4].pointPrecdt = 7;
v[1].pos[4].pointPosble = 0;
v[1].pos[4].virage = DROITE;
v[1].pos[4].parcours = 3;

v[1].pos[5].pointPrecdt = 7;
v[1].pos[5].pointPosble = 2;
v[1].pos[5].virage = GAUCHE;
v[1].pos[5].parcours = 2;

v[1].pos[6].pointPrecdt = 0;
v[1].pos[6].pointPosble = 0;
v[1].pos[6].virage = DEMIT;
v[1].pos[6].parcours = 3;

v[1].pos[7].pointPrecdt = 2;
v[1].pos[7].pointPosble = 2;
v[1].pos[7].virage = DEMIT;
v[1].pos[7].parcours = 2;

v[1].pos[8].pointPrecdt = 7;
v[1].pos[8].pointPosble = 7;
v[1].pos[8].virage = DEMIT;
v[1].pos[8].parcours = 4;



/************ V2 ************/
v[2].pos[0].pointPrecdt = 1;
v[2].pos[0].pointPosble = 3;
v[2].pos[0].virage = DEVANT;
v[2].pos[0].parcours = 3;

v[2].pos[1].pointPrecdt = 1;
v[2].pos[1].pointPosble = 6;
v[2].pos[1].virage = GAUCHE;
v[2].pos[1].parcours = 4;

v[2].pos[2].pointPrecdt = 3;
v[2].pos[2].pointPosble = 1;
v[2].pos[2].virage = DEVANT;
v[2].pos[2].parcours = 2;

v[2].pos[3].pointPrecdt = 3;
v[2].pos[3].pointPosble = 6;
v[2].pos[3].virage = DROITE;
v[2].pos[3].parcours = 4;

v[2].pos[4].pointPrecdt = 6;
v[2].pos[4].pointPosble = 1;
v[2].pos[4].virage = DROITE;
v[2].pos[4].parcours = 2;

v[2].pos[5].pointPrecdt = 6;
v[2].pos[5].pointPosble = 3;
v[2].pos[5].virage = GAUCHE;
v[2].pos[5].parcours = 3;

v[2].pos[6].pointPrecdt = 1;
v[2].pos[6].pointPosble = 1;
v[2].pos[6].virage = DEMIT;
v[2].pos[6].parcours = 2;

v[2].pos[7].pointPrecdt = 3;
v[2].pos[7].pointPosble = 3;
v[2].pos[7].virage = DEMIT;
v[2].pos[7].parcours = 3;

v[2].pos[8].pointPrecdt = 6;
v[2].pos[8].pointPosble = 6;
v[2].pos[8].virage = DEMIT;
v[2].pos[8].parcours = 4;


/************ V3 ************/
v[3].pos[0].pointPrecdt = 2;
v[3].pos[0].pointPosble = 4;
v[3].pos[0].virage = GAUCHE;
v[3].pos[0].parcours = 1;

v[3].pos[1].pointPrecdt = 4;
v[3].pos[1].pointPosble = 2;
v[3].pos[1].virage = DROITE;
v[3].pos[1].parcours = 3;

v[3].pos[2].pointPrecdt = 2;
v[3].pos[2].pointPosble = 2;
v[3].pos[2].virage = DEMIT;
v[3].pos[2].parcours = 3;

v[3].pos[3].pointPrecdt = 4;
v[3].pos[3].pointPosble = 4;
v[3].pos[3].virage = DEMIT;
v[3].pos[3].parcours = 1;



/************ V4 ************/
v[4].pos[0].pointPrecdt = 3;
v[4].pos[0].pointPosble = 5;
v[4].pos[0].virage = GAUCHE;
v[4].pos[0].parcours = 3;

v[4].pos[1].pointPrecdt = 5;
v[4].pos[1].pointPosble = 3;
v[4].pos[1].virage = DROITE;
v[4].pos[1].parcours = 1;

v[4].pos[2].pointPrecdt = 3;
v[4].pos[2].pointPosble = 3;
v[4].pos[2].virage = DEMIT;
v[4].pos[2].parcours = 1;

v[4].pos[3].pointPrecdt = 5;
v[4].pos[3].pointPosble = 5;
v[4].pos[3].virage = DEMIT;
v[4].pos[3].parcours = 3;



/************ V5 ************/
v[5].pos[0].pointPrecdt = 8;
v[5].pos[0].pointPosble = 6;
v[5].pos[0].virage = DROITE;
v[5].pos[0].parcours = 4;

v[5].pos[1].pointPrecdt = 8;
v[5].pos[1].pointPosble = 4;
v[5].pos[1].virage = DEVANT;
v[5].pos[1].parcours = 3;

v[5].pos[2].pointPrecdt = 6;
v[5].pos[2].pointPosble = 4;
v[5].pos[2].virage = DROITE;
v[5].pos[2].parcours = 3;

v[5].pos[3].pointPrecdt = 6;
v[5].pos[3].pointPosble = 8;
v[5].pos[3].virage = GAUCHE;
v[5].pos[3].parcours = 2;

v[5].pos[4].pointPrecdt = 4;
v[5].pos[4].pointPosble = 6;
v[5].pos[4].virage = GAUCHE;
v[5].pos[4].parcours = 4;

v[5].pos[5].pointPrecdt = 4;
v[5].pos[5].pointPosble = 8;
v[5].pos[5].virage = DEVANT;
v[5].pos[5].parcours = 2;

v[5].pos[6].pointPrecdt = 4;
v[5].pos[6].pointPosble = 4;
v[5].pos[6].virage = DEMIT;
v[5].pos[6].parcours = 3;

v[5].pos[7].pointPrecdt = 6;
v[5].pos[7].pointPosble = 6;
v[5].pos[7].virage = DEMIT;
v[5].pos[7].parcours = 4;

v[5].pos[8].pointPrecdt = 8;
v[5].pos[8].pointPosble = 8;
v[5].pos[8].virage = DEMIT;
v[5].pos[8].parcours = 2;


/************ V6 ************/
v[6].pos[0].pointPrecdt = 5;
v[6].pos[0].pointPosble = 7;
v[6].pos[0].virage = DROITE;
v[6].pos[0].parcours = 2;

v[6].pos[1].pointPrecdt = 5;
v[6].pos[1].pointPosble = 2;
v[6].pos[1].virage = DEVANT;
v[6].pos[1].parcours = 4;

v[6].pos[2].pointPrecdt = 7;
v[6].pos[2].pointPosble = 5;
v[6].pos[2].virage = GAUCHE;
v[6].pos[2].parcours = 4;

v[6].pos[3].pointPrecdt = 7;
v[6].pos[3].pointPosble = 2;
v[6].pos[3].virage = DROITE;
v[6].pos[3].parcours = 4;

v[6].pos[4].pointPrecdt = 2;
v[6].pos[4].pointPosble = 7;
v[6].pos[4].virage = GAUCHE;
v[6].pos[4].parcours = 2;

v[6].pos[5].pointPrecdt = 2;
v[6].pos[5].pointPosble = 5;
v[6].pos[5].virage = DEVANT;
v[6].pos[5].parcours = 4;

v[6].pos[6].pointPrecdt = 2;
v[6].pos[6].pointPosble = 2;
v[6].pos[6].virage = DEMIT;
v[6].pos[6].parcours = 4;

v[6].pos[7].pointPrecdt = 5;
v[6].pos[7].pointPosble = 5;
v[6].pos[7].virage = DEMIT;
v[6].pos[7].parcours = 4;

v[6].pos[8].pointPrecdt = 7;
v[6].pos[8].pointPosble = 7;
v[6].pos[8].virage = DEMIT;
v[6].pos[8].parcours = 2;



/************ V7 ************/
v[7].pos[0].pointPrecdt = 6;
v[7].pos[0].pointPosble = 8;
v[7].pos[0].virage = DROITE;
v[7].pos[0].parcours = 4;

v[7].pos[1].pointPrecdt = 6;
v[7].pos[1].pointPosble = 1;
v[7].pos[1].virage = GAUCHE;
v[7].pos[1].parcours = 4;

v[7].pos[2].pointPrecdt = 8;
v[7].pos[2].pointPosble = 6;
v[7].pos[2].virage = GAUCHE;
v[7].pos[2].parcours = 2;

v[7].pos[3].pointPrecdt = 8;
v[7].pos[3].pointPosble = 1;
v[7].pos[3].virage = DEVANT;
v[7].pos[3].parcours = 4;

v[7].pos[4].pointPrecdt = 1;
v[7].pos[4].pointPosble = 6;
v[7].pos[4].virage = DROITE;
v[7].pos[4].parcours = 2;

v[7].pos[5].pointPrecdt = 1;
v[7].pos[5].pointPosble = 8;
v[7].pos[5].virage = DEVANT;
v[7].pos[5].parcours = 4;

v[7].pos[6].pointPrecdt = 1;
v[7].pos[6].pointPosble = 1;
v[7].pos[6].virage = DEMIT;
v[7].pos[6].parcours = 4;

v[7].pos[7].pointPrecdt = 6;
v[7].pos[7].pointPosble = 6;
v[7].pos[7].virage = DEMIT;
v[7].pos[7].parcours = 2;

v[7].pos[8].pointPrecdt = 8;
v[7].pos[8].pointPosble = 8;
v[7].pos[8].virage = DEMIT;
v[7].pos[8].parcours = 4;



/************ V8 ************/
v[8].pos[0].pointPrecdt = 9;
v[8].pos[0].pointPosble = 7;
v[8].pos[0].virage = DROITE;
v[8].pos[0].parcours = 4;

v[8].pos[1].pointPrecdt = 9;
v[8].pos[1].pointPosble = 5;
v[8].pos[1].virage = DEVANT;
v[8].pos[1].parcours = 2;

v[8].pos[2].pointPrecdt = 7;
v[8].pos[2].pointPosble = 5;
v[8].pos[2].virage = DROITE;
v[8].pos[2].parcours = 2;

v[8].pos[3].pointPrecdt = 7;
v[8].pos[3].pointPosble = 9;
v[8].pos[3].virage = GAUCHE;
v[8].pos[3].parcours = 3;

v[8].pos[4].pointPrecdt = 5;
v[8].pos[4].pointPosble = 7;
v[8].pos[4].virage = GAUCHE;
v[8].pos[4].parcours = 4;

v[8].pos[5].pointPrecdt = 5;
v[8].pos[5].pointPosble = 9;
v[8].pos[5].virage = DEVANT;
v[8].pos[5].parcours = 3;

v[8].pos[6].pointPrecdt = 5;
v[8].pos[6].pointPosble = 5;
v[8].pos[6].virage = DEMIT;
v[8].pos[6].parcours = 2;

v[8].pos[7].pointPrecdt = 7;
v[8].pos[7].pointPosble = 7;
v[8].pos[7].virage = DEMIT;
v[8].pos[7].parcours = 4;

v[8].pos[8].pointPrecdt = 9;
v[8].pos[8].pointPosble = 9;
v[8].pos[8].virage = DEMIT;
v[8].pos[8].parcours = 3;


/************ V9 ************/
v[9].pos[0].pointPrecdt = 8;
v[9].pos[0].pointPosble = 0;
v[9].pos[0].virage = GAUCHE;
v[9].pos[0].parcours = 1;

v[9].pos[1].pointPrecdt = 0;
v[9].pos[1].pointPosble = 8;
v[9].pos[1].virage = DROITE;
v[9].pos[1].parcours = 1;

v[9].pos[6].pointPrecdt = 0;
v[9].pos[6].pointPosble = 0;
v[9].pos[6].virage = DEMIT;
v[9].pos[6].parcours = 1;

v[9].pos[7].pointPrecdt = 8;
v[9].pos[7].pointPosble = 8;
v[9].pos[7].virage = DEMIT;
v[9].pos[7].parcours = 3;

}


/*************************************************************************
 Nom de la fonction: direction().
 Utilite : Donne la direction a prendre en fonction du point actuel, 
			du point precedent et du point a rejoindre.

 
 Parametres d' entree :
 - Point actuel, point precedent, point a rejoindre, adresse du tableau
   descriptif des vertex.

 Parametres de sortie :
 - Aucuns.

 Globales  :
 - Aucunes.

 Locales principales :
 - fin, j.

 Remarque : 
 dans un souci d' optimisation de la vitesse, certains
 tests on ete omis.
 - Si un des points : precedent et a rejoindre, ne sont pas trouve la 
   boucle "while(!fin)" sera infinie et provoquera un plantage.

 - Il est donc necessaire de passer des POINTS ADJACENTS en parametres
   a la fonction ! (ce qui sera le cas du robot).
 *************************************************************************/
void direction (char pointAct, char pointPre, char pointRej, vertex v[], trame *result )
{
char j,fin;

	j=fin=0;
   while(!fin)
		{
			/*******************************************************
			recherche du point precedent et du point a rejoindre.
			*******************************************************/
			if( (v[ pointAct ].pos[j].pointPosble == pointRej) && 
				(v[ pointAct ].pos[j].pointPrecdt == pointPre) )
			{
				/**************************************
				inscription du resultat dans result[].
				***************************************/
				result->parcours = v[ pointAct ].pos[j].parcours;
     			result->virage = v[ pointAct ].pos[j].virage;
				fin = 1;
			}
			j++;
		}

}



























