/****************************************************************************
Programmation de la PMI - BTS 2000


Initialisation & supervision de la PMI


VERSION : en cours de developpement
REVISION : 08-05-2000
  
Programme par CHARNIAUX 
***************************************************************************/

#include "c:\temp\yxia\general.h"


void main (void)
{


short i;
char *courant; /* Point actuel */
char savpoint; 
char *findata; /* A INITIALISER !!! */
short resultat;
char *initState;


/*-----------------------------------------------------------------*\
|	DECLARATION DES ELEMENTS CAPITAUX
\*-----------------------------------------------------------------*/
statePMI etat;		/* Permet une vision globale de l' etat du robot */
pit_s *pit;			/* Acces aux registres du PI/T */
char ptRelier[MAX]; /* Trame des points a relier  */
vertex v[10];		/* Representation de la table */
short or_matriceW [COLONNES][LIGNES];		/* Matrice des distances */
char or_matriceT[COLONNES][LIGNES][NBCHARS];/* Matrice des trajets */
parcours *dataParc[10]; /* contient les diffrentes struct parcours */
actions  *dataAct[10];  /* contient les diffrentes struct actions  */
char newPoints[NBPOINTMAX];
unsigned long etagValeurTimer [tailleTableau];
trame *result;
trame TrameR;


/*-----------------------------------------------------------------*\
|	INITIALISATION DU ROBOT
\*-----------------------------------------------------------------*/
represTable(v); /* Construit la representation de la table */
initMatrice(or_matriceW, or_matriceT); /* Initialisation des matrices */
result = &TrameR; /* Trame du virage et du parcours */
pit=(pit_s*)0x60000;      /* Pointeur sur PI/T */

/* Initialisation des interruptions */
pit->TCR = 0xA0;          
pit->TIVR = vecteur;      
setvect(vecteur, it);

/* Initialisation des valeurs de timer */
initValeurTimer( etagValeurTimer );

/* Initialisation du chemin */
initChemin(ptRelier);
/* Fixe le point actuel */
courant = ptRelier;
courant++; 

/* Initialisation de l' etat du robot
initState = &etat;
for(i=0; i<=sizeof(etat); i++)
{
	*initState = FAUX;
	initState++;
}*/


/* fixer les valeurs par defaut de etat !!! */
etat.sens = AVANT;
etat.direction = VRAI;
etat.stateVirage = VRAI; /* pour les essai on fixera le robot sur un point,
						donc en etat virage. */
etat.assistance = VRAI;

/*-----------------------------------------------------------------*\
|	GESTION DE LA PROGRESSION & DES EVENEMENTS
\*-----------------------------------------------------------------*/
while( *courant != ENDTAB )
{



   if(etat.stateParcours == VRAI)
   {
	resultat = gererMoteurs( dataParc[result->parcours], 0);

	switch(resultat)
	{
		case CHOC :			
			if(etat.deplacmtChoc == FAUX)
       		{
       			casChoc(&etat);      			
			}
			else
			etat.chocReperage = VRAI;

		case CARREFOUR :
			etat.direction = VRAI;
			etat.stateVirage = VRAI;
			courant++; /* On a trouve le point donc on peut
					   incrementer courant */
			break;


		case PERTELIGNE :
			etat.perteLigne = VRAI;
			break;

	}

	etat.stateParcours = FAUX;
   }



	if(etat.perteLigne == VRAI)
   {
   	/* envisager une solution ! ;-) */
   	etat.perteLigne = FAUX;
   }



   if(etat.choc == VRAI)
   {
	savpoint = *courant+1;

	plusCourtChemin(*courant,*courant+1, or_matriceW, or_matriceT, newPoints);
	etat.L_overflow = maj_Liste( ptRelier, newPoints, courant, findata);

	direction(*courant, savpoint, *courant + 1, v, result);
	etat.direction = FAUX;	
	etat.stateVirage = VRAI;
	
   }


    if(etat.direction == VRAI) 
	{		
		direction(*courant, *courant - 1, *courant + 1, v, result); 
		etat.direction = FAUX;	
	}



	if(etat.stateVirage == VRAI)
    {
	if( etat.sens = AVANT )
	actionVirage( dataAct[result->virage], etat.assistance); 

	else{
		actionVirage( dataAct[!(result->virage)], etat.assistance);
		etat.sens = AVANT;
	    }

	etat.stateVirage = FAUX;
	etat.stateParcours = VRAI; /* position OK, pret pour Parcours! */	
    }
   


   if(etat.chocReperage == VRAI)
   {
     /* envisager une solution ! ;-) */

	etat.chocReperage = FAUX;
   }


	if(etat.L_overflow == OVERFLOW)
	{
		/* A A A !!!! */	
	}


   /* He Hop on continu !!! */
   

}


}




/*-----------------------------------------------------------------*\
|	GESTION DE L' EVENEMENT VIRAGE
\*-----------------------------------------------------------------*/
void actionVirage (actions *ptr, boolean assistance)
{

if( assistance == VRAI)
ptr->assistance = VRAI;

else
ptr->assistance = FAUX;

gererMoteurs( NULL, ptr);

}


/*-----------------------------------------------------------------*\
|	GESTION DE L' EVENEMENT CHOC
\*-----------------------------------------------------------------*/
short casChoc (statePMI *etatPMI)
{

parcours choc;
short result,i;
char  *init;

/* Verifier le fonctionnement !!
init = &choc;
for(i=0; i<=sizeof(choc); i++)
{
	*init = FAUX;
	init++;
}*/

etatPMI->sens = ARRIERE;

	while(VRAI)
	{
		choc.mode.sens = ARRIERE;
		choc.mode.statique = FAUX;
		choc.mode.modePrecis = VRAI;
		result = gererMoteurs( &choc, 0);

	/* Si capteur de choc a l' arriere */
	if(result == CHOC)
	{
		choc.mode.statique = VRAI;
		choc.mode.tpsStat  = TPSCASCHOC;
		choc.mode.modePrecis = FAUX;
		gererMoteurs( &choc, 0); /* Attente de TPSCASCHOC secondes */
	}

	else
	{
		if(result == CARREFOUR)
		{
			
			etatPMI->choc = VRAI;
			return CARREFOUR;
		}

		if(result == PERTELIGNE)
		{
			etatPMI->perteLigne = VRAI;
			return PERTELIGNE;
		}

      	}
	}

}


/*-----------------------------------------------------------------*\
|	FONCTION D' INITIALISATION DES VALEURS DE PRECHARG TIMER
\*-----------------------------------------------------------------*/
void initValeurTimer( unsigned long ValeurTimer[] )
{

ValeurTimer[0] = 1400;
ValeurTimer[1] = 1200;
ValeurTimer[2] = 1000;
ValeurTimer[3] = 800;
ValeurTimer[4] = 700;
ValeurTimer[5] = 600;
ValeurTimer[6] = 500;
ValeurTimer[7] = 400;
ValeurTimer[8] = 300; 
ValeurTimer[9] = 200;
ValeurTimer[10] = 100;

}



/*-----------------------------------------------------------------*\
|	FONCTION D' INITIALISATION DES POINTS A RELIER
\*-----------------------------------------------------------------*/
void initChemin( char pointR[] )
{

/* Initialiser les points a parcourir */
/*
pointR[0] = 
pointR[1] = 
pointR[2] = 
pointR[3] = 
pointR[4] = 
pointR[5] = 
pointR[6] = 
pointR[7] = 
pointR[8] = 
pointR[9] = 
pointR[10] = 
.
.
.

*/
}












            


      



























