/**************************************************************
Programmation de la PMI - BTS 2000

Programme du chemin le plus court entre deux
points. Base sur l' algorithme de Warshall il,
necessite une matrice de poids pour fonctionner.


Version fonctionnelle - revision du 07-05-2000



Remarque :
Cette fonction est aussi capable de donner le chemin
le plus court entre deux points non adjacents.


Programme par OLLIVIER Vincent.
***************************************************************/


#include "c:\temp\yxia\general.h"


void initMatrice(short or_matriceW[COLONNES][LIGNES],
			     char  or_matriceT[COLONNES][LIGNES][NBCHARS])
{

short i,j,k;

/****************************************************************************
 Afin d' optimiser la taille du code et sa lisibilit on initialise les 
 matrices avec des boucles. Puis on rempli manuellement les cases ayant des
 valeurs remarquables.
*****************************************************************************/
for( i=0; i<COLONNES; i++)
	for( j=0; j<LIGNES; j++)
   		or_matriceW[i][j] = 0;
	

for( i=0; i<COLONNES; i++)
	for( j=0; j<LIGNES; j++)
		for( k=0; k<NBCHARS; k++)
			or_matriceT[i][j][k] = 0;


for( i=0; i<COLONNES; i++)
	for( j=0; j<LIGNES; j++)
		for( k=0; k<2; k++)
			or_matriceT[i][j][k] = '0';

/*---------------------------------------------------------------------------*\
|	INITIALISATION DE LA  MATRICE DES DISTANCES 
\*---------------------------------------------------------------------------*/ 

or_matriceW [1][0] = 70;
or_matriceW [9][0] = 150;

or_matriceW [0][1] = 70;
or_matriceW [2][1] = 130;
or_matriceW [7][1] = 75;

or_matriceW [1][2] = 130;
or_matriceW [3][2] = 70;
or_matriceW [6][2] = 75;

or_matriceW [2][3] = 70;
or_matriceW [4][3] = 150;

or_matriceW [3][4] = 150;
or_matriceW [5][4] = 70;

or_matriceW [4][5] = 70;
or_matriceW [6][5] = 75;
or_matriceW [8][5] = 130;

or_matriceW [2][6] = 75;
or_matriceW [5][6] = 75;
or_matriceW [7][6] = 130;

or_matriceW [1][7] = 75;
or_matriceW [6][7] = 130;
or_matriceW [8][7] = 75;

or_matriceW [5][8] = 130;
or_matriceW [7][8] = 75;
or_matriceW [9][8] = 70;

or_matriceW [0][9] = 150;
or_matriceW [8][9] = 70;


/*---------------------------------------------------------------------------*\
|	INITIALISATION DE LA  MATRICE DES POINTS
\*---------------------------------------------------------------------------*/ 

or_matriceT [0][1][0] = '0';
or_matriceT [0][1][1] = '1';
or_matriceT [0][9][0] = '0';
or_matriceT [0][9][1] = '9';

or_matriceT [1][0][0] = '1';
or_matriceT [1][0][1] = '0';
or_matriceT [1][2][0] = '1';
or_matriceT [1][2][1] = '2';
or_matriceT [1][7][0] = '1';
or_matriceT [1][7][1] = '7';

or_matriceT [2][1][0] = '2';
or_matriceT [2][1][1] = '1';
or_matriceT [2][3][0] = '2';
or_matriceT [2][3][1] = '3';
or_matriceT [2][6][0] = '2';
or_matriceT [2][6][1] = '6';

or_matriceT [3][2][0] = '3';
or_matriceT [3][2][1] = '2';
or_matriceT [3][4][0] = '3';
or_matriceT [3][4][1] = '4';

or_matriceT [4][3][0] = '4';
or_matriceT [4][3][1] = '3';
or_matriceT [4][5][0] = '4';
or_matriceT [4][5][1] = '5';

or_matriceT [5][4][0] = '5';
or_matriceT [5][4][1] = '4';
or_matriceT [5][6][0] = '5';
or_matriceT [5][6][1] = '6';
or_matriceT [5][8][0] = '5';
or_matriceT [5][8][1] = '8';

or_matriceT [6][2][0] = '6';
or_matriceT [6][2][1] = '2';
or_matriceT [6][5][0] = '6';
or_matriceT [6][5][1] = '5';
or_matriceT [6][7][0] = '6';
or_matriceT [6][7][1] = '7';

or_matriceT [7][1][0] = '7';
or_matriceT [7][1][1] = '1';
or_matriceT [7][6][0] = '7';
or_matriceT [7][6][1] = '6';
or_matriceT [7][8][0] = '7';
or_matriceT [7][8][1] = '8';

or_matriceT [8][5][0] = '8';
or_matriceT [8][5][1] = '5';
or_matriceT [8][7][0] = '8';
or_matriceT [8][7][1] = '7';
or_matriceT [8][9][0] = '8';
or_matriceT [8][9][1] = '9';

or_matriceT [9][0][0] = '9';
or_matriceT [9][0][1] = '0';
or_matriceT [9][8][0] = '9';
or_matriceT [9][8][1] = '8';

}



/***************************************************************************
 Nom de la fonction: plusCourtChemin().
 Utilit : Calcul le chemin le plus court entre 2 points en fonction
           de la matrice de poids.
 Valeur de renvoi: Aucune

 Paramtres d' entree :
 - Le point actuel, le point a rejoindre, l'adresse des matrices originales,
   le tableau de point a rejoindre.

 Paramtres de sortie :
 - newPts[] (tableau de pts a rejoindre)

 Globales  :
 - Aucunes

 Locales principales :
 - char trajet[COLONNES][LIGNES][NBCHARS] (image de or_matriceT).
 - short matriceQ[COLONNES][LIGNES] (image de or_matriceW).

***************************************************************************/
void plusCourtChemin (
char pointAct,
char pointRej,
short matriceW[COLONNES][LIGNES],
char  matriceT[COLONNES][LIGNES][NBCHARS],
char newPts[] )
{
short i,j,k,c,b,result;

char trajet[COLONNES][LIGNES][NBCHARS];
short matriceQ[COLONNES][LIGNES];
char buff[NBCHARS];


/*---------------------------------------------------------------------------*\
|	Remplissage de la matriceQ avant traitement. 
\*---------------------------------------------------------------------------*/ 
for( i=0; i<COLONNES; i++)
{
	for( j=0; j<LIGNES; j++)
   {
		if( matriceW[i][j] == 0) matriceQ[i][j] = INFINI;
		else matriceQ[i][j] = matriceW[i][j];

		if(i==j) matriceQ[i][j] = 0; /* on met 0 a cet endroit
      pour eviter d' avoir un trajet entre un point et ce meme point.*/
   }
}



/*---------------------------------------------------------------------------*\
|	On casse la liaison entre le point actuel et celui a rejoindre.
\*---------------------------------------------------------------------------*/ 
matriceQ[pointAct][pointRej] = INFINI;
matriceQ[pointRej][pointAct] = INFINI;


/*---------------------------------------------------------------------------*\
|	"Dump" de la matriceT dans trajet[][][].  
\*---------------------------------------------------------------------------*/ 
for( i=0; i<COLONNES; i++)
{
	for( j=0; j<LIGNES; j++)
   {
     /* Evite un appel "recursif" a strcpy ! */
     c=0;
     while(matriceT[i][j][c] != 0)
     {
     	trajet[i][j][c] = matriceT[i][j][c];
         c++;
     }
     trajet[i][j][c] = 0;

   }
}
/*---------------------------------------------------------------------------*\
|	Algorithme de Warshall modifie (Algorithme du chemin le plus court).
\*---------------------------------------------------------------------------*/ 
for( k=0; k<SPEMAT; k++)
{
	for( i=0; i<COLONNES; i++)
   {
			for( j=0; j<LIGNES; j++)
		   {

            result =  matriceQ[i][k] + matriceQ[k][j];


         	if( result <  (matriceQ[i][j]) )
            {
               /***************************
				 strcpy(buff,trajet[i][k]) 
			   ****************************/
               c=0;
               while(trajet[i][k][c] != 0)
               {
                	buff[c] = trajet[i][k][c];
                  c++;
					}
               buff[c] = 0;
			   /************************************************
                strcpy(trajet[i][j], strcat(buff, trajet[k][j]))
			   *************************************************/
               c=0;
               while(buff[c] != 0) c++;
               b = c;
               c = 0;
               while(trajet[k][j][c] != 0)
               {
                   buff[b+c] = trajet[k][j][c];
                   c++;
               }
               buff[b+c] = 0;

               c = 0;
               while( buff[c] != 0)
               {
                  trajet[i][j][c] = buff[c];
                  c++;
               }
               trajet[i][j][c] = 0;
		
               matriceQ[i][j]= result;
            }
         }
	}
}


/*---------------------------------------------------------------------------*\
|	 Renvoi de la trame des points a rejoindre.
\*---------------------------------------------------------------------------*/ 
i =0;
j =1;
while( trajet[pointAct][pointRej][j] != 0 )
{
	newPts[i] = trajet[pointAct][pointRej][j];
   /* Macro permettant de modifier les chars en nombres. */
   CHAR_TO_NOMBRE(newPts[i]); i++;
   if( trajet[pointAct][pointRej][j] == trajet[pointAct][pointRej][j+1])
   j+=2;
   else j++;

}
newPts[i-1] = INDICFINTRAME;

}


