/*******************************************************************************
Programmation de la PMI - BTS 2000
						
  
Version	fonctionnelle - revision du 20-06-2000
							
Fonction suivi de ligne.
							  
Offre au robot une capacite de suivi de ligne, de detection de virage, 
et  d' alignement en virage.						
									  
********************************************************************************
*Paramtres:   Entree : etat du pmi: ligne,virage,alignement
*              Sortie : detection du virage 1.2.3 ou 4 pour alignement du robot
*
* Globales  :  Entree :aucune
*              Sortie :aucune
*
* Locales principales : Vald valeur des capteurs sur PI/T
* Programme par CHARNIAUX Francois
*******************************************************************************/
#include "c:\temp\yxia\general.h"

int Suivi(octet etatpmi)
 {
   int retour;
   octet Vald; 
  Vald= ~(pit->PBDR);
  	

  	switch(etatpmi)
	{
		case LIGNEDROITE:
		ligne(Vald);
		return OK;

		case ATTENTEVIR:
		retour=virage(Vald);
		break;

		case ALIGN:
		retour=alignement(Vald);
		break;
      }

	return retour; 
}



/*---------------------------------------------------------------------------*\
|							-Sous programme de Suivi de ligne-
\*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*\
|							-Correction de la derive du robot-
\*---------------------------------------------------------------------------*/
void ligne(octet d_vald)
{   
	octet d_Vald;
    	d_Vald= d_vald & 0x03;

   if(d_Vald==0x03)
    {
	portA(hfDriverD,FULL);
	portA(hfDriverG,FULL);
    }

   else
    {
    	if(d_Vald==0x01){portA(hfDriverG,HALF);}	/*Halfstep Droit*/
    	if(d_Vald==0x02){portA(hfDriverD,HALF);}	/*Halfstep Gauche*/
    }
    
}



/*---------------------------------------------------------------------------*\
|								-Detection d'un Virage-
\*---------------------------------------------------------------------------*/
int virage(octet d_vald)
{
	octet d_Vald;
	int retour=OK;
	
  if(d_vald<0x0f)
   {

    	d_Vald= d_vald & 0x03;

   	if(d_Vald==0x03)
    	{
		portA(hfDriverD,FULL);
		portA(hfDriverG,FULL);
    	}
  	else
        {
    	if(d_Vald==0x01){portA(hfDriverG,HALF);}	/*Halfstep Droit*/
    	if(d_Vald==0x02){portA(hfDriverD,HALF);}	/*Halfstep Gauche*/
        }
   }
 	  
  if(d_vald>0x0f)
   { 	
       d_Vald= d_vald &0xf0;
       if(d_Vald!=0xf0)
        {
		portA(hfDriverD,FULL);
		portA(hfDriverG,FULL);

       		if(d_Vald=0xA0)
    		 {
		   retour=VIRDROITE;  /*virage a Droite*/
       	 	}
        	if(d_Vald=0x50)
        	 {
        	  retour= VIRGAUCHE;	 /*virage a Gauche*/
         	}
	 }
      if(d_vald==0xf0)
       {
        retour= CARREFOUR;	/*carrefour*/
       }
	

    }


       return retour;
}
/*---------------------------------------------------------------------------*\
|	               -Detection de l'alignement du robot-
\*---------------------------------------------------------------------------*/ 
int alignement(octet d_vald)
{	octet DDIODE;
	DDIODE= d_vald &0x03;
  	

	if((DDIODE<=0x03)&&(DDIODE!=0))
  	{
  		while(DDIODE!=0x00)          /*attente de fin de ligne droite */
     		{                             /*	 en rotation robot*/
    		 DDIODE= ~(pit->PBDR);
  			 DDIODE= DDIODE &0x03;
     		}
  	}
  	
	while(DDIODE!=0x03)               /*attente d'une nouvelle ligne*/
  	{
  		 DDIODE= ~(pit->PBDR);
  		 DDIODE= DDIODE &0x03;
    }

    return ALIGNEMENT;   /*detection de l'alignement sur ligne*/
}