/**************************************************************
Programmation de la PMI - BTS 2000

  
Programme modifiant la liste des points
a rejoindre.

Version fonctionnelle - Revision 07-05-2000

Programme par OLLIVIER Vincent
***************************************************************/


#include "c:\temp\yxia\general.h"



/*****************************************************
Nom de la fonction: maj_Liste
Utilite: Met a jour la liste des points a parcourir
en cas de choc et apres re-evaluation de la trajectoire.
Valeur de renvoi: 0 et OVERFLOW
Parametres:  Entree : char tabPoints[],short *ajt, short *courant, 
					  short *findata
             Sortie : char tabPoints[].
Globales  :  Aucunes.
             
Locales principales :
- short *ptr, *ajtnew, *fintab, i.

remarque :
le tableau points doit etre assez grand pour contenir
les eventuelles modifications de trajectoires de la PMI.
Le prob vient du fait que sans systeme d' exploitation
une allocation dynamique de memoire est impossible, il
faut donc surdimensionner le tableau des points pour
eviter touts desagrements.
*****************************************************/
short maj_Liste (char tabPoints[], char *ajt, char *courant, char *findata)
{
short i;

char *ptr;
char *ajtnew;
char *fintab;

ptr = findata;

/*---------------------------------------------------------------------------*\
|	Fixe fintab a la fin du tab points pour tester un overflow.
\*---------------------------------------------------------------------------*/
fintab = tabPoints + MAX;


/*---------------------------------------------------------------------------*\
|	Decale le pointeur de fin de donnees et test un eventuel overflow.
\*---------------------------------------------------------------------------*/
ajtnew = ajt;
while( (*ajtnew != ENDTAB) )
{
   if( findata >= fintab ) return OVERFLOW;
	findata += 1;
	ajtnew += 1;
}

/*---------------------------------------------------------------------------*\
|	Decale toutes les donnees, apres le pointeur courant, vers *findata.
\*---------------------------------------------------------------------------*/
i=0;
while( ptr != courant )
{
	findata -= i;
   *findata = *ptr;
   findata += i;
   ptr -= 1;
   i++;
}



/*---------------------------------------------------------------------------*\
|	Ajoute les nouveaux points dans la liste.
\*---------------------------------------------------------------------------*/
ajtnew = ajt;
ptr += 1;
while( *ajtnew != ENDTAB)
{
	*ptr = *ajt;
   ptr += 1;
   ajtnew += 1;
}


return 0;
}







